## org.apache.xml.serialize
Class HTMLSerializer

    java.lang.Object
      org.apache.xml.serialize.BaseMarkupSerializer
          org.apache.xml.serialize.HTMLSerializer

All Implemented Interfaces:
  DOMSerializer, Serializer, org.xml.sax.ContentHandler, org.xml.sax.DocumentHandler, org.xml.sax.DTDHandler, org.xml.sax.ext.DeclHandler, org.xml.sax.ext.LexicalHandler

Direct Known Subclasses:
  XHTMLSerializer

Deprecated. This class was deprecated in Xerces 2.6.2. It is recommended that new applications use JAXP's Transformation API for XML (TrAX) for serializing HTML. See the Xerces documentation for more information.

    public class HTMLSerializer

extends BaseMarkupSerializer

Implements an HTML/XHTML serializer supporting both DOM and SAX pretty serializing. HTML/XHTML mode is determined in the constructor. For usage instructions see `Serializer`.

If an output stream is used, the encoding is taken from the output format (defaults to `UTF-8`). If a writer is used, make sure the writer uses the same encoding (if applies) as specified in the output format.

The serializer supports both DOM and SAX. DOM serializing is done by calling `BaseMarkupSerializer.serialize(org.w3c.dom.Element)` and SAX serializing is done by firing SAX events and using the serializer as a document handler.

If an I/O exception occurs while serializing, the serializer will not throw an exception directly, but only throw it at the end of serializing (either DOM or SAX's `DocumentHandler.endDocument()`.

For elements that are not specified as whitespace preserving, the serializer will potentially break long text lines at space boundaries, indent lines, and serialize elements on separate lines. Line terminators will be regarded as spaces, and spaces at beginning of line will be stripped.

XHTML is slightly different than HTML:

- Element/attribute names are lower case and case matters
- Attributes must specify value, even if empty string
- Empty elements must have '/' in empty tag
- Contents of SCRIPT and STYLE elements serialized as CDATA

Version:
  $Revision: 464300 $ $Date: 2006-10-15 17:56:26 -0400 (Sun, 15 Oct 2006) $
Author:
  Assaf Arkin
See Also:
  `Serializer`

Field Summary
`static java.lang.String` `XHTMLNamespace` Deprecated.

Fields inherited from class org.apache.xml.serialize.BaseMarkupSerializer
`_docTypePublicId, _docTypeSystemId, _encodingInfo, _format, _indenting, _prefixes, _printer, _started, fCurrentNode, fDOMError, fDOMErrorHandler, fDOMFilter, features, fStrBuffer`

Constructor Summary
`` `HTMLSerializer()` Deprecated. Constructs a new serializer.
`protected` `HTMLSerializer(boolean xhtml, OutputFormat format)` Deprecated. Constructs a new HTML/XHTML serializer depending on the value of `xhtml`.
`` `HTMLSerializer(OutputFormat format)` Deprecated. Constructs a new serializer.
`` `HTMLSerializer(java.io.OutputStream output, OutputFormat format)` Deprecated. Constructs a new serializer that writes to the specified output stream using the specified output format.
`` `HTMLSerializer(java.io.Writer writer, OutputFormat format)` Deprecated. Constructs a new serializer that writes to the specified writer using the specified output format.

Method Summary
`void` `characters(char[] chars, int start, int length)` Deprecated. Receive notification of character data.
`protected void` `characters(java.lang.String text)` Deprecated. Called to print the text contents in the prevailing element format.
`void` `endElement(java.lang.String tagName)` Deprecated. Receive notification of the end of an element.
`void` `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)` Deprecated. Receive notification of the end of an element.
`void` `endElementIO(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName)` Deprecated.
`protected java.lang.String` `escapeURI(java.lang.String uri)` Deprecated.
`protected java.lang.String` `getEntityRef(int ch)` Deprecated. Returns the suitable entity reference for this character value, or null if no such entity exists.
`protected void` `serializeElement(org.w3c.dom.Element elem)` Deprecated. Called to serialize a DOM element.
`void` `setOutputFormat(OutputFormat format)` Deprecated. Specifies an output format for this serializer.
`void` `setXHTMLNamespace(java.lang.String newNamespace)` Deprecated.
`protected void` `startDocument(java.lang.String rootTagName)` Deprecated. Called to serialize the document's DOCTYPE by the root element.
`void` `startElement(java.lang.String tagName, org.xml.sax.AttributeList attrs)` Deprecated. Receive notification of the beginning of an element.
`void` `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String rawName, org.xml.sax.Attributes attrs)` Deprecated. Receive notification of the beginning of an element.

Methods inherited from class org.apache.xml.serialize.BaseMarkupSerializer

`asContentHandler, asDocumentHandler, asDOMSerializer, attributeDecl, checkUnboundNamespacePrefixedNode, comment, comment, content, elementDecl, endCDATA, endDocument, endDTD, endEntity, endNonEscaping, endPrefixMapping, endPreserving, enterElementState, externalEntityDecl, fatalError, getElementState, getPrefix, ignorableWhitespace, internalEntityDecl, isDocumentState, leaveElementState, modifyDOMError, notationDecl, prepare, printCDATAText, printDoctypeURL, printEscaped, printEscaped, printText, printText, processingInstruction, processingInstructionIO, reset, serialize, serialize, serialize, serializeNode, serializePreRoot, setDocumentLocator, setOutputByteStream, setOutputCharStream, skippedEntity, startCDATA, startDocument, startDTD, startEntity, startNonEscaping, startPrefixMapping, startPreserving, surrogates, unparsedEntityDecl`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### XHTMLNamespace

    public static final java.lang.String XHTMLNamespace

  Deprecated.
  See Also:
    Constant Field Values

Constructor Detail

### HTMLSerializer

    protected HTMLSerializer(boolean xhtml,
                             OutputFormat format)

  Deprecated.
  Constructs a new HTML/XHTML serializer depending on the value of `xhtml`. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

  Parameters:
    `xhtml` - True if XHTML serializing

### HTMLSerializer

    public HTMLSerializer()

  Deprecated.
  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(OutputFormat format)

  Deprecated.
  Constructs a new serializer. The serializer cannot be used without calling `BaseMarkupSerializer.setOutputCharStream(java.io.Writer)` or `BaseMarkupSerializer.setOutputByteStream(java.io.OutputStream)` first.

### HTMLSerializer

    public HTMLSerializer(java.io.Writer writer,
                          OutputFormat format)

  Deprecated.
  Constructs a new serializer that writes to the specified writer using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `writer` - The writer to use
    `format` - The output format to use, null for the default

### HTMLSerializer

    public HTMLSerializer(java.io.OutputStream output,
                          OutputFormat format)

  Deprecated.
  Constructs a new serializer that writes to the specified output stream using the specified output format. If `format` is null, will use a default output format.

  Parameters:
    `output` - The output stream to use
    `format` - The output format to use, null for the default

Method Detail

### setOutputFormat

    public void setOutputFormat(OutputFormat format)

  Deprecated.
  Description copied from interface: `Serializer`
  Specifies an output format for this serializer. It the serializer has already been associated with an output format, it will switch to the new format. This method should not be called while the serializer is in the process of serializing a document.

  Specified by:
    `setOutputFormat` in interface `Serializer`
  Overrides:
    `setOutputFormat` in class `BaseMarkupSerializer`
  Parameters:
    `format` - The output format to use

### setXHTMLNamespace

    public void setXHTMLNamespace(java.lang.String newNamespace)

  Deprecated.

### startElement

    public void startElement(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName,
                             org.xml.sax.Attributes attrs)
                      throws org.xml.sax.SAXException

  Deprecated.
  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding `endElement` event for every startElement event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement event.

  This event allows up to three name components for each element:

  1. the Namespace URI;
  2. the local name; and
  3. the qualified (prefixed) name.

  Any or all of these may be provided, depending on the values of the http://xml.org/sax/features/namespaces and the http://xml.org/sax/features/namespace-prefixes properties:

  - the Namespace URI and local name are required when the namespaces property is true (the default), and are optional when the namespaces property is false (if one is specified, both must be);
  - the qualified name is required when the namespace-prefixes property is true, and is optional when the namespace-prefixes property is false (the default).

  Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted. The attribute list will contain attributes used for Namespace declarations (xmlns* attributes) only if the `http://xml.org/sax/features/namespace-prefixes` property is true (it is false by default, and support for a true value is optional).

  Like `characters()`, attribute values may have characters that need more than one `char` value.

  Parameters:
    `namespaceURI` - the Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed
    `localName` - the local name (without prefix), or the empty string if Namespace processing is not being performed
    `rawName` - the qualified name (with prefix), or the empty string if qualified names are not available
    `attrs` - the attributes attached to the element. If there are no attributes, it shall be an empty Attributes object. The value of this object after startElement returns is undefined
  Throws:
    `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception
  See Also:
    `ContentHandler.endElement(java.lang.String, java.lang.String, java.lang.String)`, `Attributes`, `AttributesImpl`

### endElement

    public void endElement(java.lang.String namespaceURI,
                           java.lang.String localName,
                           java.lang.String rawName)
                    throws org.xml.sax.SAXException

  Deprecated.
  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding `startElement` event for every endElement event (even when the element is empty).

  For information on the names, see startElement.

  Parameters:
    `namespaceURI` - the Namespace URI, or the empty string if the element has no Namespace URI or if Namespace processing is not being performed
    `localName` - the local name (without prefix), or the empty string if Namespace processing is not being performed
    `rawName` - the qualified XML name (with prefix), or the empty string if qualified names are not available
  Throws:
    `org.xml.sax.SAXException` - any SAX exception, possibly wrapping another exception

### endElementIO

    public void endElementIO(java.lang.String namespaceURI,
                             java.lang.String localName,
                             java.lang.String rawName)
                      throws java.io.IOException

  Deprecated.
  Throws:
    `java.io.IOException`

### characters

    public void characters(char[] chars,
                           int start,
                           int length)
                    throws org.xml.sax.SAXException

  Deprecated.
  Description copied from interface: `org.xml.sax.ContentHandler`
  Receive notification of character data.

  The Parser will call this method to report each chunk of character data. SAX parsers may return all contiguous character data in a single chunk, or they may split it into several chunks; however, all of the characters in any single event must come from the same external entity so that the Locator provides useful information.

  The application must not attempt to read from the array outside of the specified range.

  Individual characters may consist of more than one Java `char` value. There are two important cases where this happens, because characters can't be represented in just sixteen bits. In one case, characters are represented in a Surrogate Pair, using two special Unicode values. Such characters are in the so-called "Astral Planes", with a code point above U+FFFF. A second case involves composite characters, such as a base character combining with one or more accent characters.

  Your code should not assume that algorithms using `char`-at-a-time idioms will be working in character units; in some cases they will split characters. This is relevant wherever XML permits arbitrary characters, such as attribute values, processing instruction data, and comments as well as in data reported from this method. It's also generally relevant whenever Java code manipulates internationalized text; the issue isn't unique to XML.

  Note that some parsers will report whitespace in element content using the `ignorableWhitespace` method rather than this one (validating parsers must do so).

  Specified by:
    `characters` in interface `org.xml.sax.ContentHandler`
  Specified by:
    `characters` in interface `org.xml.sax.DocumentHandler`
  Overrides:
    `characters` in class `BaseMarkupSerializer`
  Parameters:
    `chars` - the characters from the XML document
    `start` - the start position in the array
    `length` - the number of characters to read from the array
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `ContentHandler.ignorableWhitespace(char[], int, int)`, `Locator`

### startElement

    public void startElement(java.lang.String tagName,
                             org.xml.sax.AttributeList attrs)
                      throws org.xml.sax.SAXException

  Deprecated.
  Description copied from interface: `org.xml.sax.DocumentHandler`
  Receive notification of the beginning of an element.

  The Parser will invoke this method at the beginning of every element in the XML document; there will be a corresponding endElement() event for every startElement() event (even when the element is empty). All of the element's content will be reported, in order, before the corresponding endElement() event.

  If the element name has a namespace prefix, the prefix will still be attached. Note that the attribute list provided will contain only attributes with explicit values (specified or defaulted): #IMPLIED attributes will be omitted.

  Parameters:
    `tagName` - The element type name.
    `attrs` - The attributes attached to the element, if any.
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.
  See Also:
    `DocumentHandler.endElement(java.lang.String)`, `AttributeList`

### endElement

    public void endElement(java.lang.String tagName)
                    throws org.xml.sax.SAXException

  Deprecated.
  Description copied from interface: `org.xml.sax.DocumentHandler`
  Receive notification of the end of an element.

  The SAX parser will invoke this method at the end of every element in the XML document; there will be a corresponding startElement() event for every endElement() event (even when the element is empty).

  If the element name has a namespace prefix, the prefix will still be attached to the name.

  Parameters:
    `tagName` - The element type name
  Throws:
    `org.xml.sax.SAXException` - Any SAX exception, possibly wrapping another exception.

### startDocument

    protected void startDocument(java.lang.String rootTagName)
                          throws java.io.IOException

  Deprecated.
  Called to serialize the document's DOCTYPE by the root element. The document type declaration must name the root element, but the root element is only known when that element is serialized, and not at the start of the document.

  This method will check if it has not been called before (`BaseMarkupSerializer._started`), will serialize the document type declaration, and will serialize all pre-root comments and PIs that were accumulated in the document (see `BaseMarkupSerializer.serializePreRoot()`). Pre-root will be serialized even if this is not the first root element of the document.

  Throws:
    `java.io.IOException`

### serializeElement

    protected void serializeElement(org.w3c.dom.Element elem)
                             throws java.io.IOException

  Deprecated.
  Called to serialize a DOM element. Equivalent to calling `startElement(java.lang.String, java.lang.String, java.lang.String, org.xml.sax.Attributes)`, `endElement(java.lang.String, java.lang.String, java.lang.String)` and serializing everything inbetween, but better optimized.

  Specified by:
    `serializeElement` in class `BaseMarkupSerializer`
  Parameters:
    `elem` - The element to serialize
  Throws:
    `java.io.IOException` - An I/O exception occured while serializing

### characters

    protected void characters(java.lang.String text)
                       throws java.io.IOException

  Deprecated.
  Description copied from class: `BaseMarkupSerializer`
  Called to print the text contents in the prevailing element format. Since this method is capable of printing text as CDATA, it is used for that purpose as well. White space handling is determined by the current element state. In addition, the output format can dictate whether the text is printed as CDATA or unescaped.

  Overrides:
    `characters` in class `BaseMarkupSerializer`
  Parameters:
    `text` - The text to print
  Throws:
    `java.io.IOException` - An I/O exception occured while serializing

### getEntityRef

    protected java.lang.String getEntityRef(int ch)

  Deprecated.
  Description copied from class: `BaseMarkupSerializer`
  Returns the suitable entity reference for this character value, or null if no such entity exists. Calling this method with `'&'` will return `"&amp;"`.

  Specified by:
    `getEntityRef` in class `BaseMarkupSerializer`
  Parameters:
    `ch` - Character value
  Returns:
    Character entity name, or null

### escapeURI

    protected java.lang.String escapeURI(java.lang.String uri)

  Deprecated.

Copyright © 1999-2007 The Apache Software Foundation. All Rights Reserved.